package Mathfnc;
use Exporter;
@ISA = qw(Exporter);

@EXPORT = qw(Bssl0 Bssl1);

sub kai($){
    my $n = shift;
    
    my $ret = 1;
    for($i = 1; $i< $n; $i++){
	$ret *= ($i+1);
    }
    return($ret);
}

sub sqr_kai($$){
    my ($x, $k) = @_;
    my $i;
    
    my $ret = $k ==0 ? 1 : $x;
    for($i=1; $i < $k; $i++){
	$ret *= $x/($i+1.);
    }
    $ret;
}
	
sub Bssl1($){
    my $x = shift;
    
    my $lmt =1.e-5;
    $term=1;
    
    my $sgn=-1;
    my $ord=1;
    my $y = ($x*0.5)*($x*0.5);
    my $sum=1;
    while($term> $lmt){
	$term = &sqr_kai($y, $ord) / &kai($ord+1);
	$sum += $sgn * $term;
	$sgn *= -1;
	$ord++;
    }

    my $ret = 0.5*$x * $sum;
}

sub Bssl0($){
    my $x = shift;
    
    my $lmt =1.e-5;
    $term=1;
    
    my $sgn=-1;
    my $ord=1;
    my $y = ($x*0.5)*($x*0.5);
    my $sum=1;
    while($term> $lmt){
	$term = &sqr_kai($y, $ord) / &kai($ord);
	$sum += $sgn * $term;
	$sgn *= -1;
	$ord++;
    }

    $sum;
}
