#
#  Communication Server module for  sever and client for correlation processing
#  @Auther: by M.Sekido 
#  @Date:  2007.5.18 
#
#
package Cor_com_clt;
use Exporter;
use lib "$ENV{HOME}/prog/perl/module";
use Logsys;
use IO::Socket;                   # IO::Socket ⥸塼Ȥ
#use Term::ANSIScreen qw/:color :cursor :screen :keyboard/;
@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
    
}

DESTROY{
  
}

sub new ($){
    my $pkg = shift;
    my $this = {
	'DBG' => 0, 'MON'=>0 };
    bless $this;
    $this;
}

sub Set_logfile($$){
     my ($pkg,$logfile) = @_;
     my $logsys = new Logsys;
     return -1 if($logsys->Set_logfile($logfile) <0);
     $pkg->{logsys}=$logsys;
 }

sub Message($$){
    my ($pkg,$msg) = @_;
    return unless(defined($pkg->{logsys}));
    $pkg->{logsys}->Message($msg);
}

sub Set_dbg($$){
    $pkg = shift;
    $pkg->{'DBG'} = 1;
}
sub Set_monit($$){
    $pkg = shift;
    $pkg->{'MON'} = 1;
}
# sub Try($$){
#     my ($pkg, $t1) = @_;
#     my $i = $pkg->{i};
#     my $nh = @${$pkg->{hosts}};
#     while(Send_time($i,$t1) <0){
# 	$i ++;
# 	$i %=  $nh;
#     }
    
# }

# sub Send_time($$$){
#     my ($pkg, $ih, $t1) = @_;

#     my $h =${$pkg->{hosts}}[$ih];
#     print STDERR "Trying to send job to $h\n";

#     unless ( $h =~/(\S+):(\d+)/){
# 	print STDERR "Error in Send_ScanNo(): host-entry ($h) unmatched\n";
# 	return -1;
#     }
#     my $host = $1;
#     my $port = $2;
#     my $remote = IO::Socket::INET->new(Proto    => "tcp",
# 				       PeerAddr => $host,
# 				       PeerPort => $port );
#     if($remote ==0){
# 	print STDERR "cannot connect to $host:$port \n";
# 	return -1;
#     }
#     printf $remote "Scan: %s", $t1->Str_fmt1();
#     close($remote);

#     return 0;
# }

sub Set_CorSrvs($\@){
    my ($pkg, $hlist) = @_;
    $pkg->{hosts} = $hlist;
}

sub CorSrvs($){
    my $pkg = shift;
    $pkg->{hosts}
}

sub Init_Cor($$){
    my ($pkg,$h) =@_;
    my $conf = $pkg->{conf};

    unless ( $h =~/(\S+):(\d+)/){
	print STDERR 
	    "Error in Cor_com_clt::Init_Corsrvs(): host-entry ($h) unmatched\n";
	return -1;
    }
    my $host = $1;
    my $port = $2;
    my $remote = IO::Socket::INET->new(Proto    => "tcp",
				       PeerAddr => $host,
				       PeerPort => $port );
    unless(defined($remote)){

	print STDERR "Error in Cor_com_clt::Init_Corsrvs:";
	print STDERR " cannot connect to $host:$port \n";

	$pkg->Message(sprintf("Error in Cor_com_clt::Init_Corsrvs:cannot connect to $host:$port"));
	return -1;
    }
    $pkg->Send_setting($remote,$h);
    close($remote);
    print STDERR "Cor Setup finished for $h\n";
    return 1;
} 

sub Send_setting($$$){
    my ($pkg, $remote,$h) = @_;
    my $conf = $pkg->{conf};

    select($remote); $|=1;
    select(STDERR);
    printf $remote "Lag: %d\n", $conf->Lag();
    printf $remote "Integ: %d\n", $conf->Integ();
    printf $remote "Stofst: %d\n", $conf->Stofst();
    printf $remote "Prog: %s\n", $conf->Prog();
    printf $remote "Aprdir: %s\n", $conf->Aprdir();
    printf $remote "Odir: %s\n", $conf->Odir();
    printf $remote "Mgrport: %d \n",$pkg->{mgrport} 
    if(defined($pkg->{mgrport}));
    $pkg->Message(sprintf("Lag: %d\n", $conf->Lag()));
    $pkg->Message(sprintf("Aprdir: %s\n", $conf->Aprdir()));
    $pkg->Message(sprintf("Odir: %s\n", $conf->Odir()));
    $pkg->Message(sprintf("Mgrport: %d \n",$pkg->{mgrport}))
	if(defined($pkg->{mgrport}));
    $pkg->Message("Cor Setup finished for $h\n"); 
}

sub Set_Mgrport($$){
    my $pkg = shift;
    $pkg->{mgrport} = shift;
}

## Initialize Corrlation servers
sub Init_Corsrvs($$){
    my ($pkg,$conf) = @_;
    
    $pkg->{conf} = $conf;
    my $hlist = $pkg->CorSrvs();
    foreach $h (@$hlist){
	if( $pkg->Init_Cor($h) <0){
	    print STDERR "Error: $h initialize failed\n";
	}
    }
}

## Survey if the cor-servers are free or busy.
sub Survey($){
    my $pkg = shift;
    my $hlist = $pkg->CorSrvs();
    my $host_recd = $pkg->{host_recd};
    
    my $nhost = @$hlist;
    for(my $ihost = 0; $ihost<$nhost; $ihost++){
	my $h = $$hlist[$ihost];
	unless ( $h =~/(\S+):(\d+)/){
	    print STDERR "Error in Cor_com_clt::Survey(): host-entry ($h) unmatched\n";
	    next;
	}
	
	printf STDERR "Survery to %s ...",$h if($pkg->{'DBG'});
	$pkg->Message( "Survery to $h ...");
	my $host = $1;
	my $port = $2;
	my $remote = IO::Socket::INET->new(Proto    => "tcp",
					   PeerAddr => $host,
					   PeerPort => $port );
	unless(defined($remote)){
	    print STDERR "failed \n" if($pkg->{'DBG'});
	    $pkg->Message("failed \n",1);
	    next;
	}
	print STDERR "Success, " if($pkg->{'DBG'});
	$pkg->Message("Success, ",1); 
	select($remote); $|=1;
	select(STDERR);
	print $remote "Jobs?\n";
	while(<$remote>){
#	    print STDERR "msg=$_";
	    if(/Jobs:\s*(\d+)\s+(\d+)\s+(\d+)/){
		my @cnt = ($1,$2,$3,$ihost);
		printf STDERR " jobs ret= %2d %2d %2d %2d\n",@cnt  if($pkg->{'DBG'});
		my $recd_cnt = $host_recd->{$h};
		@$recd_cnt = @cnt;
		$host_recd->{$h} = $recd_cnt;
		if($pkg->{'DBG'}){
		    printf STDERR " has %d finished %d working %d waiting jobs\n",
		    ${$host_recd->{$h}}[0], ${$host_recd->{$h}}[1],${$host_recd->{$h}}[2];
		}
		$pkg->Message(sprintf( " has %d finished %d working %d waiting jobs\n",
			       ${$host_recd->{$h}}[0], ${$host_recd->{$h}}[1],
			       ${$host_recd->{$h}}[2]),1);
		last;
	    }
	}
	close($remote);
    }
    $pkg->{host_recd} = $host_recd;

}

# sub Set_Lag($$){
#     my ($pkg, $lag) = @_;
#     $pkg->{lag} = $lag;
# }

# sub Set_Tpp($$){
#     my ($pkg, $tpp) = @_;
#     $pkg->{tpp} = $tpp;
# }

sub Send_job($$$){
    my ($pkg, $h, $job) = @_;
    
    unless ( $h =~/(\S+):(\d+)/){
	print STDERR "Error in Cor_com_clt::Send_job(): host-entry ($h) unmatched\n";
	return -1;
    }
    my $host = $1;
    my $port = $2;
    my $remote = IO::Socket::INET->new(Proto    => "tcp",
				       PeerAddr => $host,
				       PeerPort => $port );
    return -1 unless(defined($remote));

    ## Setup for correlation agent.
    $pkg->Send_setting($remote,$h);

    select($remote);    $|=1;
    unless(defined($remote)){
	print STDERR "cannot connect to $host:$port \n";
	return -1;
    }

    print STDERR "HOST: $h  JOB: $job\n"  if($pkg->{'DBG'});
    unless($job=~/(\S+):([a-z,A-Z]+):([a-z,A-Z])/){
	print STDERR "Error in Cor_com_clt::Send_job(): unexpeced job($job) \n";
	return -1;
    };
    
    printf $remote "Scan: %s %s %s\n", $1, $2, $3;
    while(<$remote>){
	chomp;
	if(/([A-Z]+):/){
	    my $ret = $1;
	    if($ret =~/OK/){
		print STDERR "$h: OK, Job ($_) threw.\n"  if($pkg->{'MON'});
		$pkg->Message("$h: OK, Job ($_) threw.\n");
		return 1;
	    }else{
		print STDERR "$h Refused.\n"   if($pkg->{'DBG'});
		$pkg->Message("$h Refused.\n"); 
		return -1;
	    }
	}
    }
    close($remote);
    
}

sub Wait_timer($){
    my ($lev) = @_;
    my @sintvl = qw(1 2 4 8 16 32 64 128 256 512 1024 2048);
    my $t0 = time;
    while(time - $t0 < $sintvl[$lev]){
	printf STDOUT "Wait timer %d sec...\n", time - $t0 if($pkg->{'DBG'});
	sleep(1);
    }
    $lev++;
    return -1  if($lev > @sintvl);
    return $lev;
}

sub Throw_jobs($$){
    my ($pkg, $bjobs) = @_;
    my @sintvl = qw(1 2 4 8 16 16 16 16 16 16 16 16 16 16 16 16 16 16 16 16 16);
#    $sintvl =10;
    $pkg->Survey();
#    my $host = $pkg->{hlist};
    my $host_recd = $pkg->{host_recd};
#    my @h_ord =  sort {${$host_recd->{$a}}[1] <=> ${$host_recd->{$b}}[1] } keys(%$host_recd);
    my @h_ord =  sort {${$host_recd->{$a}}[3] <=> ${$host_recd->{$b}}[3] } keys(%$host_recd);
    my $ih =0;
    while(@$bjobs && $ih < @h_ord){
	my $job = shift(@$bjobs);
	my $iret=0;
#	my $iret2=0;
	my $irot=0;
	while($iret <1 ){
	    $ih++ while( $ih < @h_ord && 
			 ($iret = $pkg->Send_job($h_ord[$ih], $job)) <0 );
	    if($iret <1){
#		$iret2 = &Wait_timer($irot++);
		print STDERR "Wait $sintvl[$irot] sec..." if($pkg->{'DBG'});
		if($irot < $#sintvl){
		    sleep($sintvl[$irot++]);
		}else{
		    sleep(16);
		}
		$ih=0; 
	    }
	}
#	if($iret2 <0){
	if($irot >= @sintvl){
	    print STDERR "Fatal error: Failed to throw jobs \n";
	    exit(1);
	}
	$irot=0;
	if ($ih < @h_ord){
	    printf STDERR "Job: %s sent to $h_ord[$ih] \n",$job;
	    $pkg->Message("Job: $job sent to $h_ord[$ih] \n"); 
	}else{
	    my $tmp = join(" ", @bjobs);
	    print STDERR "Warning: JOB: $tmp are remaining\n";
	    last;
	}
    }
    if(@bjobs){return -1;}
    else{      return 0;}
    
}

1;
